diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/RenderScale.java b/game/client/src/main/java/net/minecraft/client/option/enums/RenderScale.java
index 8653a5e08..975813103 100644
--- a/game/client/src/main/java/net/minecraft/client/option/enums/RenderScale.java
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/RenderScale.java
@@ -2,11 +2,14 @@ package net.minecraft.client.option.enums;
 
 public enum RenderScale {
 
+	SCALE_0625(0.0625, false),
+	SCALE_125(0.125, false),
 	SCALE_25(0.25, false),
 	SCALE_50(0.5, false),
 	SCALE_100(1.0, true),
-	SCALE_200(2.0, true);
-	
+	SCALE_200(2.0, true),
+	SCALE_400(4.0, true);
+
 	public final double scale;
 	public final boolean useLinearFiltering;
 	
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java
new file mode 100644
index 000000000..d8fa8116d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelButtonPainted.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockModelButtonPainted<T extends BlockLogic> extends BlockModelStandard<T> {
+    protected final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    public BlockModelButtonPainted(final Block<T> block) {
+        super(block);
+        for (final DyeColor c : DyeColor.blockOrderedColors()){
+            this.texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
+        }
+    }
+
+    @Override
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final Side side, final int meta) {
+        return this.texCoords[(meta >> 4) & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index a1b152b1c..a25d6f762 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -475,6 +475,8 @@ public final class BlockModelDispatcher
         final float height = 0.125F;
         final float depth = 0.125F;
         addDispatch(new BlockModelStandard<>(Blocks.BUTTON_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone").withCustomItemBounds(0.5F - width, 0.5F - height, 0.5F - depth, 0.5F + width, 0.5F + height, 0.5F + depth));
+        addDispatch(new BlockModelStandard<>(Blocks.BUTTON_PLANKS).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak").withCustomItemBounds(0.5F - width, 0.5F - height, 0.5F - depth, 0.5F + width, 0.5F + height, 0.5F + depth));
+        addDispatch(new BlockModelButtonPainted<>(Blocks.BUTTON_PLANKS_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak").withCustomItemBounds(0.5F - width, 0.5F - height, 0.5F - depth, 0.5F + width, 0.5F + height, 0.5F + depth));
 
         addDispatch(new BlockModelLever<>(Blocks.LEVER_COBBLE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lever_cobbled_stone"));
 
@@ -484,6 +486,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
         addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
         addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_COBBLE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
+        addDispatch(new BlockModelPressurePlatePainted<>(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
 
         addDispatch(new BlockModelVeryRotatable<>(Blocks.MOTION_SENSOR_IDLE)
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/motion_sensor/side")
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java
new file mode 100644
index 000000000..7f08fa84c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockModelPressurePlatePainted<T extends BlockLogic> extends BlockModelStandard<T> {
+    protected final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    public BlockModelPressurePlatePainted(final Block<T> block) {
+        super(block);
+        for (final DyeColor c : DyeColor.blockOrderedColors()){
+            this.texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
+        }
+    }
+
+    @Override
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final Side side, final int meta) {
+        return this.texCoords[(meta >> 4) & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 9f53e013a..1664cf66c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -10,6 +10,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
@@ -53,32 +54,32 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         float blue = color.getBlue() / 255.0f;
 
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y, z, 1) || !worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y - 1, z, -1);
-        boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y, z, 3) || !worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y - 1, z, -1);
-        boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z - 1, 2) || !worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y - 1, z - 1, -1);
-        boolean south = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z + 1, 0) || !worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y - 1, z + 1, -1);
+        boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y, z, Side.WEST) || !worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x - 1, y - 1, z, Side.NONE, Side.BOTTOM);
+        boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y, z, Side.EAST) || !worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x + 1, y - 1, z, Side.NONE, Side.BOTTOM);
+        boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z - 1, Side.NORTH) || !worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y - 1, z - 1, Side.NONE, Side.BOTTOM);
+        boolean south = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z + 1, Side.SOUTH) || !worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y - 1, z + 1, Side.NONE, Side.BOTTOM);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
         if(!worldSource.isBlockOpaqueCube(x, y + 1, z))
         {
-            if(worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y + 1, z, -1))
+            if(worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x - 1, y + 1, z, Side.NONE, Side.TOP))
             {
                 west = true;
                 westUp = true;
             }
-            if(worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y + 1, z, -1))
+            if(worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x + 1, y + 1, z, Side.NONE, Side.TOP))
             {
                 east = true;
                 eastUp = true;
             }
-            if(worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y + 1, z - 1, -1))
+            if(worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y + 1, z - 1, Side.NONE, Side.TOP))
             {
                 north = true;
                 northUp = true;
             }
-            if(worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y + 1, z + 1, -1))
+            if(worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y + 1, z + 1, Side.NONE, Side.TOP))
             {
                 south = true;
                 southUp = true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index ee8c08f96..a85ea86a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -9,6 +9,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
@@ -18,7 +19,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicButton extends BlockLogic
+public class BlockLogicButton extends BlockLogic implements IPaintable
 {
     public static final int MASK_POWERED = 0b0000_1000;
     public static final int MASK_DIRECTION = 0b0000_0111;
@@ -290,7 +291,7 @@ public class BlockLogicButton extends BlockLogic
         {
             return true;
         }
-        world.setBlockMetadataWithNotify(x, y, z, direction | MASK_POWERED);
+        world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | direction | MASK_POWERED);
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.6F);
         world.notifyBlocksOfNeighborChange(x, y, z, block.id());
@@ -430,4 +431,20 @@ public class BlockLogicButton extends BlockLogic
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.5F);
         world.markBlocksDirty(x, y, z, x, y, z);
     }
+
+    @Override
+    public boolean canBePainted() {
+        return id() == Blocks.BUTTON_PLANKS.id();
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataRaw(x, y, z, Blocks.BUTTON_PLANKS_PAINTED.id(), meta);
+        world.setBlockMetadata(x, y, z, meta);
+        Blocks.BUTTON_PLANKS_PAINTED.getLogic().setColor(world, x, y, z, color);
+        if ((meta & MASK_POWERED) != 0) {
+            world.scheduleBlockUpdate(x, y, z, Blocks.BUTTON_PLANKS_PAINTED.id(), tickDelay());
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
new file mode 100644
index 000000000..1b9d8fa47
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicButtonPainted extends BlockLogicButton implements IPainted{
+    public BlockLogicButtonPainted(Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    public boolean canBePainted() {
+        return true;
+    }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta >> 4);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & (MASK_POWERED | MASK_DIRECTION);
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockWithNotify(x, y, z, Blocks.BUTTON_PLANKS.id());
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(@Nullable final Player player, final ItemStack stack, final World world, final int x, final int y, final int z, final Side side, final double xPlaced, final double yPlaced) {
+        return stack.getMetadata() & ~(MASK_POWERED | MASK_DIRECTION);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, stripColorFromMetadata(meta) | toMetadata(color));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 7575767fc..2edc7d431 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.WorldSource;
@@ -13,10 +14,10 @@ import org.jetbrains.annotations.NotNull;
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
+public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable
 {
     public static final int MASK_POWERED = 0b0000_0001;
-    public static final int MASK_CEILING = 0b0000_0010;
+    public static final int MASK_SIDE = 0b0000_1110;
     private final Class<T> triggerMobClass;
 
 	public BlockLogicPressurePlate(Block<?> block, Class<T> mobType, Material material)
@@ -55,7 +56,12 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) || world.isBlockNormalCube(x, y + 1, z);
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) ||
+            world.isBlockNormalCube(x, y + 1, z) ||
+            world.isBlockNormalCube(x + 1, y, z) ||
+            world.isBlockNormalCube(x - 1, y, z) ||
+            world.isBlockNormalCube(x, y, z + 1) ||
+            world.isBlockNormalCube(x, y, z - 1);
     }
 
     @Override
@@ -97,10 +103,20 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
-        boolean isCeiling = onCeiling(meta);
+        Side side = sideFromMeta(world.getBlockMetadata(x, y, z));
         boolean isSteppedOn = false;
-        float f = 0.125F;
-        List<T> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
+        float pixel = 0.125F;
+        List<T> list;
+        switch (sideFromMeta(meta)) {
+            case BOTTOM: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel).move(x, y, z)); break;
+            case TOP: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).move(x, y, z)); break;
+            case NORTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel)).move(x, y, z)); break;
+            case SOUTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1).move(x, y, z)); break;
+            case WEST: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel).move(x, y, z)); break;
+            case EAST:
+            default: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).move(x, y, z)); break;
+        }
+
         if(list != null && !list.isEmpty())
         {
             isSteppedOn = true;
@@ -109,7 +125,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
         {
             world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id());
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
+            world.notifyBlocksOfNeighborChange(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), id());
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.6F);
         }
@@ -117,7 +133,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
         {
             world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id());
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
+            world.notifyBlocksOfNeighborChange(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), id());
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.5F);
         }
@@ -130,11 +146,11 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        boolean isCeiling = onCeiling(world.getBlockMetadata(x, y, z));
         if(isPressed(data))
         {
+            Side side = sideFromMeta(world.getBlockMetadata(x, y, z));
             world.notifyBlocksOfNeighborChange(x, y, z, id());
-            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id());
+            world.notifyBlocksOfNeighborChange(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), id());
         }
         super.onBlockRemoved(world, x, y, z, data);
     }
@@ -144,22 +160,15 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
-        boolean isCeiling = onCeiling(meta);
         float pixel = 0.0625F;
-        if(isPressed)
-        {
-            if (isCeiling){
-                return AABB.getTemporaryBB(pixel, 1f - 0.03125F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
-            } else {
-                return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
-            }
-        } else
-        {
-            if (isCeiling){
-                return AABB.getTemporaryBB(pixel, 1f - 0.0625F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
-            } else {
-                return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
-            }
+        switch (sideFromMeta(meta)) {
+            case BOTTOM: return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel);
+            case TOP: return AABB.getTemporaryBB(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            case NORTH: return AABB.getTemporaryBB(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel));
+            case SOUTH: return AABB.getTemporaryBB(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1);
+            case WEST: return AABB.getTemporaryBB(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel);
+            case EAST:
+            default: return AABB.getTemporaryBB(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel);
         }
     }
 
@@ -174,9 +183,8 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        boolean isCeiling = onCeiling(meta);
         if(isPressed(world.getBlockMetadata(x, y, z))) {
-            return side == (isCeiling ? Side.BOTTOM : Side.TOP);
+            return side == sideFromMeta(meta).getOpposite();
         } else {
             return false;
         }
@@ -185,8 +193,12 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
         return (meta & MASK_POWERED) != 0;
     }
 
-    public static boolean onCeiling(int meta) {
-        return (meta & MASK_CEILING) != 0;
+    public static int setSide(int meta, @NotNull Side side) {
+        return (meta & ~MASK_SIDE) | (side.getId() << 1);
+    }
+
+    public static @NotNull Side sideFromMeta(int meta) {
+        return Side.getSideById((meta & MASK_SIDE) >> 1);
     }
 
     @Override
@@ -202,8 +214,27 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic
     }
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && yPlaced > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
-            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | MASK_CEILING);
+        side = side.getOpposite();
+        if (world.isBlockNormalCube(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ())) {
+            world.setBlockMetadata(x, y, z, setSide(world.getBlockMetadata(x, y, z), side));
+        } else if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z)) {
+            world.setBlockMetadata(x, y, z, setSide(world.getBlockMetadata(x, y, z), Side.BOTTOM));
+        }
+    }
+
+    @Override
+    public boolean canBePainted() {
+        return id() == Blocks.PRESSURE_PLATE_PLANKS_OAK.id();
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataRaw(x, y, z, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), meta);
+        world.setBlockMetadata(x, y, z, meta);
+        Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
+        if (isPressed(meta)) {
+            world.scheduleBlockUpdate(x, y, z, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), tickDelay());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
new file mode 100644
index 000000000..aa348bf85
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
@@ -0,0 +1,52 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicPressurePlatePainted<T extends Entity> extends BlockLogicPressurePlate<T> implements IPainted{
+    public BlockLogicPressurePlatePainted(Block<?> block, Class<T> mobType, Material material) {
+        super(block, mobType, material);
+    }
+
+    @Override
+    public boolean canBePainted() {
+        return true;
+    }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta >> 4);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & (MASK_POWERED | MASK_SIDE);
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockWithNotify(x, y, z, Blocks.PRESSURE_PLATE_PLANKS_OAK.id());
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(@Nullable final Player player, final ItemStack stack, final World world, final int x, final int y, final int z, final Side side, final double xPlaced, final double yPlaced) {
+        return stack.getMetadata() & ~(MASK_POWERED | MASK_SIDE);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, stripColorFromMetadata(meta) | toMetadata(color));
+    }
+}
